VERSION 5.00
Begin VB.Form frmListAdapters 
   Caption         =   "ListAdapters"
   ClientHeight    =   6615
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10005
   LinkTopic       =   "Form1"
   ScaleHeight     =   6615
   ScaleWidth      =   10005
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox edtTextOut 
      BackColor       =   &H80000006&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000A&
      Height          =   6615
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "ListAdapters.frx":0000
      Top             =   0
      Width           =   10035
   End
End
Attribute VB_Name = "frmListAdapters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub Form_Load()
    Dim lRes    As Long
    Dim bRes    As Boolean
       
    Dim hFilt       As Long
    Dim nBuffLen    As Long
    Dim AdList      As TCP_AdapterList
    Dim verInfo     As OSVERSIONINFO
    
    
    
    Dim sOut                As String
    Dim szFriendlyName      As String
    
    ' Allocate string buffer
    szFriendlyName = String$(MAX_PATH * 4, vbNullChar)

    verInfo.dwOSVersionInfoSize = Len(verInfo)
    lRes = GetVersionEx(verInfo)
    
    Dim nMTUDec     As Long
    nMTUDec = GetMTUDecrement()
  
    'Create driver object
    hFilt = OpenFilterDriver("NDISRD")
    
    'Check if driver loaded
    If (IsDriverLoaded(hFilt)) Then
    
        sOut = "The following network interfaces are available to MSTCP:" & vbCrLf
        GetTcpipBoundAdaptersInfo hFilt, AdList
        
        Dim i       As Integer
        For i = 0 To AdList.m_nAdapterCount - 1
            'Convert internal network interface name to user-friendly one depending of the OS        Dim i       As Integer
            If (verInfo.dwPlatformId = VER_PLATFORM_WIN32_NT) Then
            
                If (verInfo.dwMajorVersion = 5) Then
                    'Windows 2000 or XP
                    ConvertWindows2000AdapterName AdList.m_szAdapterNameList(i), szFriendlyName, MAX_PATH * 4
                
                ElseIf (verInfo.dwMajorVersion = 4) Then
                    'Windows NT 4.0
                    ConvertWindowsNTAdapterName AdList.m_szAdapterNameList(i), szFriendlyName, MAX_PATH * 4
                End If
            Else
                'Windows 9x/ME
                ConvertWindowsNTAdapterName AdList.m_szAdapterNameList(i), szFriendlyName, MAX_PATH * 4
            End If
            
            sOut = sOut & (i + 1) & ")  " & Trim0(szFriendlyName) & "." & vbCrLf
            sOut = sOut & vbTab & "Internal Name:" & vbTab & Trim0(AdList.m_szAdapterNameList(i)) & vbCrLf
'            sOut = sOut & vbTab & "Permanent MAC:" & vbTab _
'                        & Trim0(AdList.m_czPermanentAddress(i)) & vbCrLf
'            sOut = sOut & vbTab & "Permanent MAC:" & vbTab & Trim0(AdList.m_czPermanentAddress(i)) & vbCrLf
'            printf (
'                "\tPermanent MAC:\t %.2X%.2X%.2X%.2X%.2X%.2X\n",
'                AdList.m_czPermanentAddress[i][0],
'                AdList.m_czPermanentAddress[i][1],
'                AdList.m_czPermanentAddress[i][2],
'                AdList.m_czPermanentAddress[i][3],
'                AdList.m_czPermanentAddress[i][4],
'                AdList.m_czPermanentAddress[i][5]
'                );
'            printf (
'                "\tCurrent MAC:\t %.2X%.2X%.2X%.2X%.2X%.2X\n",
'                AdList.m_czCurrentAddress[i][0],
'                AdList.m_czCurrentAddress[i][1],
'                AdList.m_czCurrentAddress[i][2],
'                AdList.m_czCurrentAddress[i][3],
'                AdList.m_czCurrentAddress[i][4],
'                AdList.m_czCurrentAddress[i][5]
'                );
            sOut = sOut & vbTab & "Medium:" & vbTab & vbTab & Format(Hex(AdList.m_nAdapterMediumList(i)), "0x########") & vbCrLf
            sOut = sOut & vbTab & "Current MTU:" & vbTab & AdList.m_usMTU(i) & vbCrLf
        Next i
        sOut = sOut & vbCrLf & "Current system wide MTU decrement = " & nMTUDec

    Else
        
        sOut = sOut & "Helper driver failed to load or was not installed." & vbCrLf
    End If
    
    Me.edtTextOut = sOut
    CloseFilterDriver hFilt

    nMTUDec = 0
End Sub
