Attribute VB_Name = "modDecl_Ndisapi"
Option Explicit

'Some size constants
Public Const ADAPTER_NAME_SIZE As Long = 256
Public Const ADAPTER_LIST_SIZE As Long = 32
Public Const ETHER_ADDR_LENGTH As Long = 6
Public Const MAX_ETHER_FRAME As Long = 1514

Public Declare Function CloseFilterDriver Lib "mylib.dll" (ByVal hOpen As Long) As Boolean
Public Declare Function ConvertWindows2000AdapterName Lib "mylib.dll" (ByVal szAdapterName As String, _
                                                       ByVal szUserFriendlyName As String, _
                                                       ByRef dwUserFriendlyNameLength As Long) As Boolean
Public Declare Function ConvertWindows9xAdapterName Lib "mylib.dll" (ByVal szAdapterName As String, _
                                                       ByVal szUserFriendlyName As String, _
                                                       ByRef dwUserFriendlyNameLength As Long) As Boolean
Public Declare Function ConvertWindowsNTAdapterName Lib "mylib.dll" (ByVal szAdapterName As String, _
                                                       ByVal szUserFriendlyName As String, _
                                                       ByRef dwUserFriendlyNameLength As Long) As Boolean
Public Declare Function GetMTUDecrement Lib "mylib.dll" () As Long
Public Declare Function GetTcpipBoundAdaptersInfo Lib "mylib.dll" (ByVal hOpen As Long, ByRef Adapters As TCP_AdapterList) As Boolean
Public Declare Function IsDriverLoaded Lib "mylib.dll" (ByVal hOpen As Long) As Boolean
Public Declare Function OpenFilterDriver Lib "mylib.dll" (ByVal pszFileName As String) As Long

Public Type Byte_string
    m_cz(ETHER_ADDR_LENGTH) As Byte
End Type

'Public Type TCP_AdapterList
'    m_nAdapterCount  As Long                            'Number of adapters
'    m_szAdapterNameList(ADAPTER_LIST_SIZE)  As String * ADAPTER_NAME_SIZE 'Array of adapter names
'    m_nAdapterHandle(ADAPTER_LIST_SIZE)     As Long     'Array of adapter handles, this are key handles for any adapter relative operation
'    m_nAdapterMediumList(ADAPTER_LIST_SIZE) As Long  'List of adapter mediums
'    m_czPermanentAddress(ADAPTER_LIST_SIZE, ETHER_ADDR_LENGTH) As Byte  'permanent (hardware) ethernet address
'    m_czCurrentAddress(ADAPTER_LIST_SIZE, ETHER_ADDR_LENGTH)   As Byte 'current (configured) ethernet address
'    m_usMTU(ADAPTER_LIST_SIZE)              As Long  'current adapter MTU
'End Type

Public Type TCP_AdapterList
    m_nAdapterCount  As Long                            'Number of adapters
    m_szAdapterNameList(ADAPTER_LIST_SIZE - 1) As String * ADAPTER_NAME_SIZE 'Array of adapter names
    m_nAdapterHandle(ADAPTER_LIST_SIZE - 1)  As Long     'Array of adapter handles, this are key handles for any adapter relative operation
    m_nAdapterMediumList(ADAPTER_LIST_SIZE - 1) As Integer 'List of adapter mediums
    m_czPermanentAddress(ADAPTER_LIST_SIZE - 1) As String * ETHER_ADDR_LENGTH 'permanent (hardware) ethernet address
    m_czCurrentAddress(ADAPTER_LIST_SIZE - 1) As String * ETHER_ADDR_LENGTH 'current (configured) ethernet address
    m_usMTU(ADAPTER_LIST_SIZE - 1)          As Integer  'current adapter MTU
End Type

'Public Type TCP_AdapterList
'    m_nAdapterCount  As Long                            'Number of adapters
'    m_szAdapterNameList(ADAPTER_LIST_SIZE)  As String * ADAPTER_NAME_SIZE 'Array of adapter names
'    m_nAdapterHandle(ADAPTER_LIST_SIZE)     As Long     'Array of adapter handles, this are key handles for any adapter relative operation
'    m_nAdapterMediumList(ADAPTER_LIST_SIZE) As Integer  'List of adapter mediums
'    m_czPermanentAddress(ADAPTER_LIST_SIZE) As String * ETHER_ADDR_LENGTH 'permanent (hardware) ethernet address
'    m_czCurrentAddress(ADAPTER_LIST_SIZE)   As String * ETHER_ADDR_LENGTH 'current (configured) ethernet address
'    m_usMTU(ADAPTER_LIST_SIZE)              As Integer  'current adapter MTU
'End Type


